Index: trunk/LMDZ.GENERIC/libf/phystd/mass_redistribution.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/mass_redistribution.F90	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/mass_redistribution.F90	(revision 787)
@@ -5,4 +5,7 @@
                                                    
        USE watercommon_h, Only: Tsat_water,RLVTT
+       use surfdat_h
+       USE comgeomfi_h
+       USE tracer_h
 
        IMPLICIT NONE
@@ -49,10 +52,7 @@
 #include "dimphys.h"
 #include "comcstfi.h"
-#include "surfdat.h"
-#include "comgeomfi.h"
 #include "comvert.h"
 #include "paramet.h"
 #include "callkeys.h"
-#include "tracer.h"
 
 !-----------------------------------------------------------------------
@@ -61,6 +61,6 @@
       INTEGER ngrid, nlayer, nq   
       REAL ptimestep
-      REAL pcapcal(ngridmx)
-      INTEGER rnat(ngridmx)      
+      REAL pcapcal(ngrid)
+      INTEGER rnat(ngrid)      
       REAL pplay(ngrid,nlayer),pplev(ngrid,nlayer+1)
       REAL pt(ngrid,nlayer),pdt(ngrid,nlayer)
@@ -71,6 +71,6 @@
       REAL pdmassmr(ngrid,nlayer)
       REAL pdumr(ngrid,nlayer) , pdvmr(ngrid,nlayer)
-      REAL pq(ngridmx,nlayer,nq),pdq(ngrid,nlayer,nq)
-      REAL pqs(ngridmx,nq)
+      REAL pq(ngrid,nlayer,nq),pdq(ngrid,nlayer,nq)
+      REAL pqs(ngrid,nq)
       REAL pdqmr(ngrid,nlayer,nq),pdqsmr(ngrid,nq)
       REAL pdpsrfmr(ngrid),pdtsrfmr(ngrid)
@@ -80,5 +80,5 @@
 
 !    Boiling/sublimation
-      REAL Tsat(ngridmx),zmassboil(ngridmx)
+      REAL Tsat(ngrid),zmassboil(ngrid)
 
 !    vertical reorganization of sigma levels
@@ -87,13 +87,13 @@
 !    Dummy variables      
       INTEGER n,l,ig,iq
-      REAL zdtsig(ngridmx,nlayermx)
-      REAL zmass(ngridmx,nlayermx),zzmass(nlayermx),w(nlayermx+1)
-      REAL zdmass_sum(ngridmx,nlayermx+1)
+      REAL zdtsig(ngrid,nlayermx)
+      REAL zmass(ngrid,nlayermx),zzmass(nlayermx),w(nlayermx+1)
+      REAL zdmass_sum(ngrid,nlayermx+1)
       REAL zmflux(nlayermx+1)
       REAL zq1(nlayermx)
-      REAL ztsrf(ngridmx)
+      REAL ztsrf(ngrid)
       REAL ztm(nlayermx+1) 
       REAL zum(nlayermx+1) , zvm(nlayermx+1)
-      REAL zqm(nlayermx+1,nqmx),zqm1(nlayermx+1)
+      REAL zqm(nlayermx+1,nq),zqm1(nlayermx+1)
 
 !   local saved variables
@@ -120,7 +120,7 @@
 !     Surface tracer Tendencies set to 0
 !     -------------------------------------
-      pdqsmr(1:ngridmx,1:nqmx)=0.
-
-      ztsrf(1:ngridmx) = ptsrf(1:ngridmx) + pdtsrf(1:ngridmx)*ptimestep
+      pdqsmr(1:ngrid,1:nq)=0.
+
+      ztsrf(1:ngrid) = ptsrf(1:ngrid) + pdtsrf(1:ngrid)*ptimestep
 
 
@@ -135,10 +135,10 @@
 
       if (water) then
-         do ig=1,ngridmx
+         do ig=1,ngrid
 	    call Tsat_water(pplev(ig,1)+zdmass_sum(ig,1)*g*ptimestep,Tsat(ig))
 	 enddo
                call writediagfi(ngrid,'Tsat','saturation temperature at surface','',2,Tsat)
 	 
-         do ig=1,ngridmx
+         do ig=1,ngrid
 	    if (ztsrf(ig).gt.Tsat(ig)) then
 	       zmassboil(ig)=(ptsrf(ig)-Tsat(ig))*pcapcal(ig)/RLVTT/ptimestep
@@ -163,7 +163,7 @@
 !    """"""""""""""""""""""""""""""""""""
          
-      pdpsrfmr(1:ngridmx) = (zdmass_sum(1:ngridmx,1)+zmassboil(1:ngridmx))*g
-
-      do ig = 1, ngridmx
+      pdpsrfmr(1:ngrid) = (zdmass_sum(1:ngrid,1)+zmassboil(1:ngrid))*g
+
+      do ig = 1, ngrid
         IF(ABS(pdpsrfmr(ig)*ptimestep).GT.pplev(ig,1)) THEN
          PRINT*,'STOP in condens'
@@ -187,5 +187,5 @@
          zzu(1:nlayermx)  = pu(ig,1:nlayermx) + pdu(ig,1:nlayermx) * ptimestep
          zzv(1:nlayermx)  = pv(ig,1:nlayermx) + pdv(ig,1:nlayermx) * ptimestep
-         zzq(1:nlayermx,1:nqmx)=pq(ig,1:nlayermx,1:nqmx)+pdq(ig,1:nlayermx,1:nqmx)*ptimestep ! must add the water that has fallen???
+         zzq(1:nlayermx,1:nq)=pq(ig,1:nlayermx,1:nq)+pdq(ig,1:nlayermx,1:nq)*ptimestep ! must add the water that has fallen???
 
 !  Mass fluxes of air through the sigma levels (kg.m-2.s-1)  (>0 when up)
@@ -214,5 +214,5 @@
          zum(1) = 0.  
          zvm(1) = 0.  
-         zqm(1,1:nqmx)=0. ! most tracer do not condense !
+         zqm(1,1:nq)=0. ! most tracer do not condense !
          if (water) zqm(1,igcm_h2o_vap)=1. ! flux is 100% h2o at surface
 	 
@@ -222,5 +222,5 @@
          call vl1d(zzu ,2.,zzmass,w,zum) 
          call vl1d(zzv ,2.,zzmass,w,zvm) 
-         do iq=1,nqmx
+         do iq=1,nq
            zq1(1:nlayermx)=zzq(1:nlayermx,iq)
            zqm1(1)=zqm(1,iq)
@@ -247,5 +247,5 @@
          zum(nlayer+1)= zzu(nlayer)  ! should not be used, but...
          zvm(nlayer+1)= zzv(nlayer)  ! should not be used, but...
-         zqm(nlayer+1,1:nqmx)= zzq(nlayer,1:nqmx)
+         zqm(nlayer+1,1:nq)= zzq(nlayer,1:nq)
  
 !        Tendencies on T, U, V, Q 
@@ -267,5 +267,5 @@
 
 !        Tendencies on Q
-         do iq=1,nqmx
+         do iq=1,nq
             DO l=1,nlayer
                pdqmr(ig,l,iq)= (1/zzmass(l)) *   &
Index: trunk/LMDZ.GENERIC/libf/phystd/moistadj.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/moistadj.F90	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/moistadj.F90	(revision 787)
@@ -1,5 +1,6 @@
-subroutine moistadj(pt, pq, pdq, pplev, pplay, pdtmana, pdqmana, ptimestep, rneb)
+subroutine moistadj(ngrid, nq, pt, pq, pdq, pplev, pplay, pdtmana, pdqmana, ptimestep, rneb)
 
   use watercommon_h, only: T_h2O_ice_liq, RLVTT, RCPD, Psat_water, Lcpdqsat_water
+  USE tracer_h
 
   implicit none
@@ -21,24 +22,25 @@
 #include "dimensions.h"
 #include "dimphys.h"
-#include "tracer.h"
 #include "comcstfi.h"
 
-      REAL pt(ngridmx,nlayermx)            ! temperature (K)
-      REAL pq(ngridmx,nlayermx,nqmx)       ! tracer (kg/kg)
-      REAL pdq(ngridmx,nlayermx,nqmx)
-
-      REAL pdqmana(ngridmx,nlayermx,nqmx)  ! tendency of tracers (kg/kg.s-1)
-      REAL pdtmana(ngridmx,nlayermx)       ! temperature increment
+      INTEGER ngrid, nq
+
+      REAL pt(ngrid,nlayermx)            ! temperature (K)
+      REAL pq(ngrid,nlayermx,nq)       ! tracer (kg/kg)
+      REAL pdq(ngrid,nlayermx,nq)
+
+      REAL pdqmana(ngrid,nlayermx,nq)  ! tendency of tracers (kg/kg.s-1)
+      REAL pdtmana(ngrid,nlayermx)       ! temperature increment
 
 !     local variables
-      REAL zt(ngridmx,nlayermx)      ! temperature (K)
-      REAL zq(ngridmx,nlayermx)      ! humidite specifique (kg/kg)
-      REAL pplev(ngridmx,nlayermx+1) ! pression a inter-couche (Pa)
-      REAL pplay(ngridmx,nlayermx)   ! pression au milieu de couche (Pa)
-
-      REAL d_t(ngridmx,nlayermx)     ! temperature increment
-      REAL d_q(ngridmx,nlayermx)     ! incrementation pour vapeur d'eau
-      REAL d_ql(ngridmx,nlayermx)    ! incrementation pour l'eau liquide
-      REAL rneb(ngridmx,nlayermx) ! cloud fraction 
+      REAL zt(ngrid,nlayermx)      ! temperature (K)
+      REAL zq(ngrid,nlayermx)      ! humidite specifique (kg/kg)
+      REAL pplev(ngrid,nlayermx+1) ! pression a inter-couche (Pa)
+      REAL pplay(ngrid,nlayermx)   ! pression au milieu de couche (Pa)
+
+      REAL d_t(ngrid,nlayermx)     ! temperature increment
+      REAL d_q(ngrid,nlayermx)     ! incrementation pour vapeur d'eau
+      REAL d_ql(ngrid,nlayermx)    ! incrementation pour l'eau liquide
+      REAL rneb(ngrid,nlayermx) ! cloud fraction 
       REAL ptimestep
 
@@ -52,13 +54,13 @@
       INTEGER, PARAMETER :: niter = 1
       INTEGER k1, k1p, k2, k2p
-      LOGICAL itest(ngridmx)
-      REAL delta_q(ngridmx, nlayermx)
+      LOGICAL itest(ngrid)
+      REAL delta_q(ngrid, nlayermx)
       REAL cp_new_t(nlayermx)
       REAL cp_delta_t(nlayermx)
       REAL v_cptj(nlayermx), v_cptjk1, v_ssig
-      REAL v_cptt(ngridmx,nlayermx), v_p, v_t, zpsat
-      REAL zqs(ngridmx,nlayermx), zdqs(ngridmx,nlayermx)
-      REAL zq1(ngridmx), zq2(ngridmx)
-      REAL gamcpdz(ngridmx,2:nlayermx)
+      REAL v_cptt(ngrid,nlayermx), v_p, v_t, zpsat
+      REAL zqs(ngrid,nlayermx), zdqs(ngrid,nlayermx)
+      REAL zq1(ngrid), zq2(ngrid)
+      REAL gamcpdz(ngrid,2:nlayermx)
       REAL zdp, zdpm
 
@@ -66,5 +68,5 @@
       REAL zflo ! flotabilite
 
-      REAL local_q(ngridmx,nlayermx),local_t(ngridmx,nlayermx)
+      REAL local_q(ngrid,nlayermx),local_t(ngrid,nlayermx)
 
       REAL zdelta, zcor, zcvm5
@@ -94,10 +96,10 @@
 
 !     GCM -----> subroutine variables
-      zq(1:ngridmx,1:nlayermx)    = pq(1:ngridmx,1:nlayermx,i_h2o)+ pdq(1:ngridmx,1:nlayermx,i_h2o)*ptimestep
-      zt(1:ngridmx,1:nlayermx)    = pt(1:ngridmx,1:nlayermx)
-      pdqmana(1:ngridmx,1:nlayermx,1:nqmx)=0.0
-
-      DO k = 1, nlayermx
-       DO i = 1, ngridmx
+      zq(1:ngrid,1:nlayermx)    = pq(1:ngrid,1:nlayermx,i_h2o)+ pdq(1:ngrid,1:nlayermx,i_h2o)*ptimestep
+      zt(1:ngrid,1:nlayermx)    = pt(1:ngrid,1:nlayermx)
+      pdqmana(1:ngrid,1:nlayermx,1:nq)=0.0
+
+      DO k = 1, nlayermx
+       DO i = 1, ngrid
          if(zq(i,k).lt.0.)then
             zq(i,k)=0.0
@@ -106,14 +108,14 @@
       ENDDO
       
-      local_q(1:ngridmx,1:nlayermx) = zq(1:ngridmx,1:nlayermx)
-      local_t(1:ngridmx,1:nlayermx) = zt(1:ngridmx,1:nlayermx)
-      rneb(1:ngridmx,1:nlayermx) = 0.0
-      d_ql(1:ngridmx,1:nlayermx) = 0.0
-      d_t(1:ngridmx,1:nlayermx)  = 0.0
-      d_q(1:ngridmx,1:nlayermx)  = 0.0
+      local_q(1:ngrid,1:nlayermx) = zq(1:ngrid,1:nlayermx)
+      local_t(1:ngrid,1:nlayermx) = zt(1:ngrid,1:nlayermx)
+      rneb(1:ngrid,1:nlayermx) = 0.0
+      d_ql(1:ngrid,1:nlayermx) = 0.0
+      d_t(1:ngrid,1:nlayermx)  = 0.0
+      d_q(1:ngrid,1:nlayermx)  = 0.0
 
 !     Calculate v_cptt
       DO k = 1, nlayermx
-         DO i = 1, ngridmx
+         DO i = 1, ngrid
             v_cptt(i,k) = RCPD * local_t(i,k)
             v_t = MAX(local_t(i,k),15.)
@@ -127,5 +129,5 @@
 !     Calculate Gamma * Cp * dz: (gamma is the critical gradient)
       DO k = 2, nlayermx
-         DO i = 1, ngridmx
+         DO i = 1, ngrid
             zdp = pplev(i,k)-pplev(i,k+1)
             zdpm = pplev(i,k-1)-pplev(i,k)
@@ -138,5 +140,6 @@
 
 !------------------------------------ modification of unstable profile
-      DO 9999 i = 1, ngridmx
+      DO 9999 i = 1, ngrid
+
       itest(i) = .FALSE.
 
@@ -266,5 +269,5 @@
 
       DO k = 1, nlayermx
-      DO i = 1, ngridmx
+      DO i = 1, ngrid
          IF (itest(i)) THEN
          delta_q(i,k) = local_q(i,k) - zq(i,k)
@@ -278,5 +281,5 @@
 ! diminue et d'une maniere proportionnelle a cet diminution):
 
-      DO i = 1, ngridmx
+      DO i = 1, ngrid
          IF (itest(i)) THEN
          zq1(i) = 0.0
@@ -285,5 +288,5 @@
       ENDDO
       DO k = 1, nlayermx
-      DO i = 1, ngridmx
+      DO i = 1, ngrid
          IF (itest(i)) THEN
          zdp = pplev(i,k)-pplev(i,k+1)
@@ -294,5 +297,5 @@
       ENDDO
       DO k = 1, nlayermx
-      DO i = 1, ngridmx
+      DO i = 1, ngrid
          IF (itest(i)) THEN
            IF (zq2(i).NE.0.0) d_ql(i,k) = - MIN(0.0,delta_q(i,k))*zq1(i)/zq2(i)
@@ -304,5 +307,5 @@
 
       DO k = 1, nlayermx
-      DO i = 1, ngridmx
+      DO i = 1, ngrid
           local_q(i, k) = MAX(local_q(i, k), seuil_vap)
       ENDDO
@@ -310,5 +313,5 @@
 
       DO k = 1, nlayermx
-      DO i = 1, ngridmx
+      DO i = 1, ngrid
          d_t(i,k) = local_t(i,k) - zt(i,k)
          d_q(i,k) = local_q(i,k) - zq(i,k)
@@ -318,5 +321,5 @@
 !     now subroutine -----> GCM variables
       DO k = 1, nlayermx
-         DO i = 1, ngridmx
+         DO i = 1, ngrid
             
             pdtmana(i,k)       = d_t(i,k)/ptimestep
Index: trunk/LMDZ.GENERIC/libf/phystd/newsedim.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/newsedim.F	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/newsedim.F	(revision 787)
@@ -35,5 +35,5 @@
 c    Traceurs :
       real pqi(ngrid,nlay)  ! traceur   (e.g. ?/kg)
-      real wq(ngridmx,nlay+1)  ! flux de traceur durant timestep (?/m-2)
+      real wq(ngrid,nlay+1)  ! flux de traceur durant timestep (?/m-2)
       
 c   local:
@@ -48,7 +48,7 @@
 c    Traceurs :
 c    ~~~~~~~~ 
-      real traversee (ngridmx,nlayermx)
-      real vstokes(ngridmx,nlayermx)
-      real w(ngridmx,nlayermx)
+      real traversee (ngrid,nlayermx)
+      real vstokes(ngrid,nlayermx)
+      real w(ngrid,nlayermx)
       real ptop, dztop, Ep, Stra
 
@@ -74,11 +74,4 @@
 
       IF (firstcall) THEN
-         IF(ngrid.NE.ngridmx) THEN
-            PRINT*,'STOP dans newsedim'
-            PRINT*,'probleme de dimensions :'
-            PRINT*,'ngrid  =',ngrid
-            PRINT*,'ngridmx  =',ngridmx
-            STOP 
-         ENDIF
          firstcall=.false.
 
Index: trunk/LMDZ.GENERIC/libf/phystd/newtrelax.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/newtrelax.F90	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/newtrelax.F90	(revision 787)
@@ -1,3 +1,3 @@
-subroutine newtrelax(mu0,sinlat,popsk,temp,pplay,pplev,dtrad,firstcall) 
+subroutine newtrelax(ngrid,mu0,sinlat,popsk,temp,pplay,pplev,dtrad,firstcall) 
         
   implicit none
@@ -20,19 +20,21 @@
 !     
 !==================================================================
-  
+ 
+  integer ngrid
+ 
   ! Input
-  real mu0(ngridmx)                    ! cosine of sun incident angle
-  real sinlat(ngridmx)                 ! sine of latitude
-  real temp(ngridmx,nlayermx)          ! temperature at each layer (K)
-  real pplay(ngridmx,nlayermx)         ! pressure at each layer (Pa)
-  real pplev(ngridmx,nlayermx+1)       ! pressure at each level (Pa)
-  real popsk(ngridmx,nlayermx)         ! pot. T to T converter
+  real mu0(ngrid)                    ! cosine of sun incident angle
+  real sinlat(ngrid)                 ! sine of latitude
+  real temp(ngrid,nlayermx)          ! temperature at each layer (K)
+  real pplay(ngrid,nlayermx)         ! pressure at each layer (Pa)
+  real pplev(ngrid,nlayermx+1)       ! pressure at each level (Pa)
+  real popsk(ngrid,nlayermx)         ! pot. T to T converter
 
   ! Output
-  real dtrad(ngridmx,nlayermx) 
+  real dtrad(ngrid,nlayermx) 
 
   ! Internal
-  real Trelax(ngridmx,nlayermx), Trelax_V, Trelax_H
-  save Trelax
+  real Trelax_V, Trelax_H
+  real,allocatable,dimension(:,:),save :: Trelax
 
   real T_trop ! relaxation temperature at tropopause (K)
@@ -51,4 +53,6 @@
   if(firstcall) then
 
+     ALLOCATE(Trelax(ngrid,nlayermx))
+
      print*,'-----------------------------------------------------'
      print*,'| ATTENTION: You are using a Newtonian cooling scheme'
@@ -58,5 +62,5 @@
 
      if(tidallocked)then
-        do ig=1,ngridmx
+        do ig=1,ngrid
 
            T_surf = 126. + 239.*mu0(ig)
@@ -83,5 +87,5 @@
 
         do l=1,nlayermx
-           do ig=1,ngridmx
+           do ig=1,ngrid
 
               ! vertically varying component
@@ -111,5 +115,5 @@
   ! Calculate radiative forcing
   do l=1,nlayermx
-     do ig=1,ngridmx
+     do ig=1,ngrid
         dtrad(ig,l) = -(temp(ig,l) - Trelax(ig,l)) / tau_relax
         if(temp(ig,l).gt.500.)then ! Trelax(ig,l))then
@@ -122,6 +126,6 @@
   enddo
 
-  call writediagfi(ngridmx,'Tref','rad forc temp','K',3,Trelax)
-  !call writediagfi(ngridmx,'ThetaZ','stellar zenith angle','deg',2,mu0)
+  call writediagfi(ngrid,'Tref','rad forc temp','K',3,Trelax)
+  !call writediagfi(ngrid,'ThetaZ','stellar zenith angle','deg',2,mu0)
 
   return
Index: trunk/LMDZ.GENERIC/libf/phystd/phyetat0.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/phyetat0.F	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/phyetat0.F	(revision 787)
@@ -1,6 +1,12 @@
-      SUBROUTINE phyetat0 (fichnom,tab0,Lmodif,nsoil,nq,
+      SUBROUTINE phyetat0 (ngrid,fichnom,tab0,Lmodif,nsoil,nq,
      .           day_ini,time,
      .           tsurf,tsoil,emis,q2,qsurf,cloudfrac,totcloudfrac,hice)
+
+      USE surfdat_h
+      USE comgeomfi_h
+      USE tracer_h
+
       implicit none
+
 c======================================================================
 c Auteur(s) Z.X. Li (LMD/CNRS) date: 19930818
@@ -11,10 +17,8 @@
 #include "dimensions.h"
 #include "dimphys.h"
-#include "comgeomfi.h"
-#include "surfdat.h"
 #include "planete.h"
 #include "comcstfi.h"
-#include"advtrac.h"
-
+
+      INTEGER ngrid
 c======================================================================
       INTEGER nbsrf !Mars nbsrf a 1 au lieu de 4
@@ -33,13 +37,12 @@
 
 !  outputs:
-      real tsurf(ngridmx,nbsrf) ! surface temperature
-      real tsoil(ngridmx,nsoil,nbsrf) ! soil temperature
-      real emis(ngridmx) ! surface emissivity
-      real q2(ngridmx, llm+1) ! 
-      real qsurf(ngridmx,nq) ! tracers on surface
-!      real co2ice(ngridmx) ! co2 ice cover
-      real cloudfrac(ngridmx,nlayermx)
-      real hice(ngridmx), totcloudfrac(ngridmx)
-
+      real tsurf(ngrid,nbsrf) ! surface temperature
+      real tsoil(ngrid,nsoil,nbsrf) ! soil temperature
+      real emis(ngrid) ! surface emissivity
+      real q2(ngrid, llm+1) ! 
+      real qsurf(ngrid,nq) ! tracers on surface
+!      real co2ice(ngrid) ! co2 ice cover
+      real cloudfrac(ngrid,nlayermx)
+      real hice(ngrid), totcloudfrac(ngrid)
 
 
@@ -71,5 +74,25 @@
       character(len=30) :: txt ! to store some text
 
- 
+!! added variables by AS to allow to read only slices of startfi
+      real :: toto(ngrid)
+      integer :: sta   !! subscript in starti where we start to read
+      integer, dimension(2) :: sta2d
+      integer, dimension(2) :: siz2d
+
+c AS: get the cursor that is stored in dimphys.h
+c ... this allows to read only a part of startfi horiz grid
+      sta = cursor
+
+c
+c ALLOCATE ARRAYS IN surfdat_h
+c
+      IF (.not. ALLOCATED(albedodat)) ALLOCATE(albedodat(ngrid))
+      IF (.not. ALLOCATED(phisfi)) ALLOCATE(phisfi(ngrid))
+      IF (.not. ALLOCATED(zmea)) ALLOCATE(zmea(ngrid))
+      IF (.not. ALLOCATED(zstd)) ALLOCATE(zstd(ngrid))
+      IF (.not. ALLOCATED(zsig)) ALLOCATE(zsig(ngrid))
+      IF (.not. ALLOCATED(zgam)) ALLOCATE(zgam(ngrid))
+      IF (.not. ALLOCATED(zthe)) ALLOCATE(zthe(ngrid))
+
 c
 c Ouvrir le fichier contenant l etat initial:
@@ -85,5 +108,5 @@
 !                    qsurf02, ...)
       count=0
-      do iq=1,nqmx
+      do iq=1,nq
         txt= " "
         write(txt,'(a5,i2.2)')'qsurf',iq
@@ -97,5 +120,5 @@
         endif
       enddo
-      if (count.eq.nqmx) then
+      if (count.eq.nq) then
         write(*,*) "phyetat0:tracers seem to follow old naming ",
      &             "convention (qsurf01,qsurf02,...)"
@@ -106,8 +129,8 @@
 
 c modifications possibles des variables de tab_cntrl
-      PRINT*
       write(*,*) 'TABFI de phyeta0',Lmodif,tab0
-      call tabfi (nid,Lmodif,tab0,day_ini,lmax,p_rad,
+      call tabfi (ngrid,nid,Lmodif,tab0,day_ini,lmax,p_rad,
      .              p_omeg,p_g,p_cpp,p_mugaz,p_daysec,time)
+
 c
 c Lecture des latitudes (coordonnees):
@@ -119,7 +142,7 @@
       ENDIF
 #ifdef NC_DOUBLE
-      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, lati)
-#else
-      ierr = NF_GET_VAR_REAL(nid, nvarid, lati)
+      ierr = NF_GET_VARA_DOUBLE(nid,nvarid,sta,ngrid,lati)
+#else
+      ierr = NF_GET_VARA_REAL(nid,nvarid,sta,ngrid,lati)
 #endif
       IF (ierr.NE.NF_NOERR) THEN
@@ -136,7 +159,7 @@
       ENDIF
 #ifdef NC_DOUBLE
-      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, long)
-#else
-      ierr = NF_GET_VAR_REAL(nid, nvarid, long)
+      ierr = NF_GET_VARA_DOUBLE(nid,nvarid,sta,ngrid,long)
+#else
+      ierr = NF_GET_VARA_REAL(nid,nvarid,sta,ngrid,long)
 #endif
       IF (ierr.NE.NF_NOERR) THEN
@@ -153,7 +176,7 @@
       ENDIF
 #ifdef NC_DOUBLE
-      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, area)
-#else
-      ierr = NF_GET_VAR_REAL(nid, nvarid, area)
+      ierr = NF_GET_VARA_DOUBLE(nid,nvarid,sta,ngrid,area)
+#else
+      ierr = NF_GET_VARA_REAL(nid,nvarid,sta,ngrid,area)
 #endif
       IF (ierr.NE.NF_NOERR) THEN
@@ -175,7 +198,7 @@
       ENDIF
 #ifdef NC_DOUBLE
-      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, phisfi)
-#else
-      ierr = NF_GET_VAR_REAL(nid, nvarid, phisfi)
+      ierr = NF_GET_VARA_DOUBLE(nid,nvarid,sta,ngrid,phisfi)
+#else
+      ierr = NF_GET_VARA_REAL(nid,nvarid,sta,ngrid,phisfi)
 #endif
       IF (ierr.NE.NF_NOERR) THEN
@@ -197,7 +220,7 @@
       ENDIF
 #ifdef NC_DOUBLE
-      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, albedodat)
-#else
-      ierr = NF_GET_VAR_REAL(nid, nvarid, albedodat)
+      ierr = NF_GET_VARA_DOUBLE(nid,nvarid,sta,ngrid,albedodat)
+#else
+      ierr = NF_GET_VARA_REAL(nid,nvarid,sta,ngrid,albedodat)
 #endif
       IF (ierr.NE.NF_NOERR) THEN
@@ -211,26 +234,4 @@
       PRINT*,'Albedo du sol nu <albedodat>:', xmin, xmax
 c
-c Lecture de l''inertie thermique du sol:
-c
-!      ierr = NF_INQ_VARID (nid, "inertiedat", nvarid)
-!      IF (ierr.NE.NF_NOERR) THEN
-!         PRINT*, 'phyetat0: Le champ <inertiedat> est absent'
-!         CALL abort
-!      ENDIF
-!#ifdef NC_DOUBLE
-!      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, inertiedat)
-!#else
-!      ierr = NF_GET_VAR_REAL(nid, nvarid, inertiedat)
-!#endif
-!      IF (ierr.NE.NF_NOERR) THEN
-!         PRINT*, 'phyetat0: Lecture echouee pour <inertiedat>'
-!         CALL abort
-!      ENDIF
-!      xmin = 1.0E+20
-!      xmax = -1.0E+20
-!      xmin = MINVAL(inertiedat)
-!      xmax = MAXVAL(inertiedat)
-!      PRINT*,'Inertie thermique du sol <inertiedat>:', xmin, xmax
-c
 c ZMEA
 c
@@ -241,7 +242,7 @@
       ENDIF
 #ifdef NC_DOUBLE
-      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, zmea)
-#else
-      ierr = NF_GET_VAR_REAL(nid, nvarid, zmea)
+      ierr = NF_GET_VARA_DOUBLE(nid,nvarid,sta,ngrid,zmea)
+#else
+      ierr = NF_GET_VARA_REAL(nid,nvarid,sta,ngrid,zmea)
 #endif
       IF (ierr.NE.NF_NOERR) THEN
@@ -251,5 +252,5 @@
       xmin = 1.0E+20
       xmax = -1.0E+20
-      DO i = 1, ngridmx
+      DO i = 1, ngrid
          xmin = MIN(zmea(i),xmin)
          xmax = MAX(zmea(i),xmax)
@@ -265,7 +266,7 @@
       ENDIF
 #ifdef NC_DOUBLE
-      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, zstd)
-#else
-      ierr = NF_GET_VAR_REAL(nid, nvarid, zstd)
+      ierr = NF_GET_VARA_DOUBLE(nid,nvarid,sta,ngrid,zstd)
+#else
+      ierr = NF_GET_VARA_REAL(nid,nvarid,sta,ngrid,zstd)
 #endif
       IF (ierr.NE.NF_NOERR) THEN
@@ -275,5 +276,5 @@
       xmin = 1.0E+20
       xmax = -1.0E+20
-      DO i = 1, ngridmx
+      DO i = 1, ngrid
          xmin = MIN(zstd(i),xmin)
          xmax = MAX(zstd(i),xmax)
@@ -289,7 +290,7 @@
       ENDIF
 #ifdef NC_DOUBLE
-      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, zsig)
-#else
-      ierr = NF_GET_VAR_REAL(nid, nvarid, zsig)
+      ierr = NF_GET_VARA_DOUBLE(nid,nvarid,sta,ngrid,zsig)
+#else
+      ierr = NF_GET_VARA_REAL(nid,nvarid,sta,ngrid,zsig)
 #endif
       IF (ierr.NE.NF_NOERR) THEN
@@ -299,5 +300,5 @@
       xmin = 1.0E+20
       xmax = -1.0E+20
-      DO i = 1, ngridmx
+      DO i = 1, ngrid
          xmin = MIN(zsig(i),xmin)
          xmax = MAX(zsig(i),xmax)
@@ -313,7 +314,7 @@
       ENDIF
 #ifdef NC_DOUBLE
-      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, zgam)
-#else
-      ierr = NF_GET_VAR_REAL(nid, nvarid, zgam)
+      ierr = NF_GET_VARA_DOUBLE(nid,nvarid,sta,ngrid,zgam)
+#else
+      ierr = NF_GET_VARA_REAL(nid,nvarid,sta,ngrid,zgam)
 #endif
       IF (ierr.NE.NF_NOERR) THEN
@@ -323,5 +324,5 @@
       xmin = 1.0E+20
       xmax = -1.0E+20
-      DO i = 1, ngridmx
+      DO i = 1, ngrid
          xmin = MIN(zgam(i),xmin)
          xmax = MAX(zgam(i),xmax)
@@ -337,7 +338,7 @@
       ENDIF
 #ifdef NC_DOUBLE
-      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, zthe)
-#else
-      ierr = NF_GET_VAR_REAL(nid, nvarid, zthe)
+      ierr = NF_GET_VARA_DOUBLE(nid,nvarid,sta,ngrid,zthe)
+#else
+      ierr = NF_GET_VARA_REAL(nid,nvarid,sta,ngrid,zthe)
 #endif
       IF (ierr.NE.NF_NOERR) THEN
@@ -347,5 +348,5 @@
       xmin = 1.0E+20
       xmax = -1.0E+20
-      DO i = 1, ngridmx
+      DO i = 1, ngrid
          xmin = MIN(zthe(i),xmin)
          xmax = MAX(zthe(i),xmax)
@@ -413,7 +414,7 @@
          PRINT*, '          J ignore donc les autres temperatures TS**'
 #ifdef NC_DOUBLE
-         ierr = NF_GET_VAR_DOUBLE(nid, nvarid, tsurf(1,1))
-#else
-         ierr = NF_GET_VAR_REAL(nid, nvarid, tsurf(1,1))
+         ierr = NF_GET_VARA_DOUBLE(nid, nvarid, sta, ngrid, tsurf)
+#else
+         ierr = NF_GET_VARA_REAL(nid, nvarid, sta, ngrid, tsurf)
 #endif
          IF (ierr.NE.NF_NOERR) THEN
@@ -428,5 +429,5 @@
          IF (nbsrf >= 2) THEN
             DO nsrf = 2, nbsrf
-               DO i = 1, ngridmx
+               DO i = 1, ngrid
                   tsurf(i,nsrf) = tsurf(i,1)
                ENDDO
@@ -448,5 +449,5 @@
 !               PRINT*, "phyetat0: Le champ <tsoil> est absent"
 !               PRINT*, "          Il prend donc la valeur de surface"
-!               DO i=1, ngridmx
+!               DO i=1, ngrid
 !                  tsoil(i,isoil,nsrf)=tsurf(i,nsrf)
 !               ENDDO
@@ -478,7 +479,7 @@
       ENDIF
 #ifdef NC_DOUBLE
-      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, emis)
-#else
-      ierr = NF_GET_VAR_REAL(nid, nvarid, emis)
+      ierr = NF_GET_VARA_DOUBLE(nid, nvarid, sta,ngrid, emis)
+#else
+      ierr = NF_GET_VARA_REAL(nid, nvarid,sta,ngrid, emis)
 #endif
       IF (ierr.NE.NF_NOERR) THEN
@@ -501,8 +502,10 @@
 !         CALL abort
       ENDIF
-#ifdef NC_DOUBLE
-      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, cloudfrac)
-#else
-      ierr = NF_GET_VAR_REAL(nid, nvarid, cloudfrac)
+      sta2d = (/sta,1/)
+      siz2d = (/ngrid, nlayermx/)
+#ifdef NC_DOUBLE
+      ierr = NF_GET_VARA_DOUBLE(nid,nvarid,sta2d,siz2d,cloudfrac)
+#else
+      ierr = NF_GET_VARA_REAL(nid,nvarid,sta2d,siz2d,cloudfrac)
 #endif
       IF (ierr.NE.NF_NOERR) THEN
@@ -528,7 +531,7 @@
       ENDIF
 #ifdef NC_DOUBLE
-      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, totcloudfrac)
-#else
-      ierr = NF_GET_VAR_REAL(nid, nvarid, totcloudfrac)
+      ierr = NF_GET_VARA_DOUBLE(nid, nvarid,sta,ngrid, totcloudfrac)
+#else
+      ierr = NF_GET_VARA_REAL(nid, nvarid,sta,ngrid, totcloudfrac)
 #endif
       IF (ierr.NE.NF_NOERR) THEN
@@ -553,7 +556,7 @@
       ENDIF
 #ifdef NC_DOUBLE
-      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, hice)
-#else
-      ierr = NF_GET_VAR_REAL(nid, nvarid, hice)
+      ierr = NF_GET_VARA_DOUBLE(nid, nvarid,sta,ngrid, hice)
+#else
+      ierr = NF_GET_VARA_REAL(nid, nvarid,sta,ngrid, hice)
 #endif
       IF (ierr.NE.NF_NOERR) THEN
@@ -576,8 +579,10 @@
          CALL abort
       ENDIF
-#ifdef NC_DOUBLE
-      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, q2)
-#else
-      ierr = NF_GET_VAR_REAL(nid, nvarid, q2)
+      sta2d = (/sta,1/)
+      siz2d = (/ngrid, llm+1/)
+#ifdef NC_DOUBLE
+      ierr = NF_GET_VARA_DOUBLE(nid,nvarid,sta2d,siz2d,q2)
+#else
+      ierr = NF_GET_VARA_REAL(nid,nvarid,sta2d,siz2d,q2)
 #endif
       IF (ierr.NE.NF_NOERR) THEN
@@ -604,5 +609,5 @@
              write(txt,'(a5,i2.2)')'qsurf',iq
            ELSE
-             txt=tnom(iq)
+             txt=noms(iq)
 !             if (txt.eq."h2o_vap") then
                ! There is no surface tracer for h2o_vap;
@@ -618,13 +623,14 @@
      &                  ' not found in file'
              write(*,*) trim(txt), ' set to 0'
-             do ig=1,ngridmx
+             do ig=1,ngrid
                qsurf(ig,iq)=0.
              end do
              nqold=min(iq-1,nqold)
            ELSE
-#ifdef NC_DOUBLE
-             ierr = NF_GET_VAR_DOUBLE(nid, nvarid,qsurf(1,iq))
-#else
-             ierr = NF_GET_VAR_REAL(nid, nvarid,qsurf(1,iq))
+           toto(:) = 0.
+#ifdef NC_DOUBLE
+           ierr = NF_GET_VARA_DOUBLE(nid,nvarid,sta,ngrid,toto)
+#else
+           ierr = NF_GET_VARA_REAL(nid,nvarid,sta,ngrid,toto)
 #endif
              IF (ierr.NE.NF_NOERR) THEN
@@ -632,9 +638,10 @@
                CALL abort
              ENDIF
+             qsurf(1:ngrid,iq) = toto(1:ngrid)
            ENDIF
            xmin = 1.0E+20
            xmax = -1.0E+20
-           xmin = MINVAL(qsurf(1:ngridmx,iq))
-           xmax = MAXVAL(qsurf(1:ngridmx,iq))
+           xmin = MINVAL(qsurf(1:ngrid,iq))
+           xmax = MAXVAL(qsurf(1:ngrid,iq))
            PRINT*,'tracer on surface <',trim(txt),'>:',xmin,xmax
          ENDDO
@@ -642,20 +649,20 @@
 c        case when new tracer are added in addition to old ones
              write(*,*)'qsurf 1 to ', nqold,'were already present'
-             write(*,*)'qsurf ', nqold+1,' to ', nqmx,'are new'
+             write(*,*)'qsurf ', nqold+1,' to ', nq,'are new'
              write(*,*)' and initialized to zero'
-             qsurf(:,nqold+1:nqmx)=0.0
+             qsurf(:,nqold+1:nq)=0.0
 !            yes=' '
 !            do while ((yes.ne.'y').and.(yes.ne.'n'))
 !             write(*,*) 'Would you like to reindex qsurf # 1 ->',nqold
-!             write(*,*) 'to #',nqmx-nqold+1,'->', nqmx,'   (y or n) ?'
+!             write(*,*) 'to #',nq-nqold+1,'->', nq,'   (y or n) ?'
 !             read(*,fmt='(a)') yes
 !            end do
 !            if (yes.eq.'y') then
 !              write(*,*) 'OK, let s reindex qsurf'
-!                 do ig=1,ngridmx
-!                    do iq=nqmx,nqmx-nqold+1,-1
-!                       qsurf(ig,iq)=qsurf(ig,iq-nqmx+nqold)
+!                 do ig=1,ngrid
+!                    do iq=nq,nq-nqold+1,-1
+!                       qsurf(ig,iq)=qsurf(ig,iq-nq+nqold)
 !                    end do
-!                    do iq=nqmx-nqold,1,-1
+!                    do iq=nq-nqold,1,-1
 !                       qsurf(ig,iq)= 0.
 !                    end do
@@ -668,5 +675,6 @@
 ! as well as thermal inertia and volumetric heat capacity
 
-      call soil_settings(nid,ngridmx,nsoil,tsurf,tsoil)
+      PRINT*,'SOIL INIT'
+      call soil_settings(nid,ngrid,nsoil,tsurf,tsoil)
 c
 c Fermer le fichier:
@@ -674,4 +682,5 @@
       ierr = NF_CLOSE(nid)
 c
+
       RETURN
       END
